#ifndef BIT_EXCEPTIONS_HH
#define BIT_EXCEPTIONS_HH

#include <stdexcept>

namespace bit {

  /** Thrown to report invalid arguments to functions.  */
  class invalid_argument : public std::invalid_argument
  {
  public:
    explicit invalid_argument(const std::string&  __arg) 
      : std::invalid_argument(__arg) { }
  };

  /** Thrown to report values that exceed the expected range. */
  class out_of_range : public std::out_of_range
  {
  public:
    explicit out_of_range(const std::string&  __arg) 
      : std::out_of_range(__arg) { }
  };

  /** Thrown to report invalid method calls. */
  class invalid_call : public std::logic_error 
  {
  public:
    explicit invalid_call(const std::string&  __arg) 
      : logic_error(__arg) { }
  };

  /** Thrown to report input output errors. */
  class io_error : public std::runtime_error
  {
  public:
    explicit io_error(const std::string&  __arg) 
      : runtime_error(__arg) { }
  };

};

#endif /* BIT_EXCEPTIONS_HH */
