#include "kn/Kneser.hh"
#include "util/util.hh"
#include "io/io.hh"

using namespace bit;

typedef Kneser::FloatVec FloatVec;
typedef Kneser::IntVec IntVec;

int
main(int argc, char *argv[])
{
  std::vector<FloatVec> d2_num;
  std::vector<IntVec> d2_norm;

  {
    io::Stream file(argv[1]);
    fprintf(stderr, "reading d1\n");
    {
      std::vector<FloatVec> d1;
      util::read(file, d1);
    }
    fprintf(stderr, "reading d2\n");
    util::read(file, d2_num);
    fprintf(stderr, "reading d2_norm\n");
    util::read(file, d2_norm);
  }

  size_t num_ngrams = 0;
  for (size_t o = 0; o < d2_num.size(); o++) {
    fprintf(stderr, "%zd-grams: %zd\n", o + 1, d2_num[o].size());
    num_ngrams += d2_num[o].size();
  }

  fprintf(stderr, "computing d2\n");
  FloatVec d2;
  d2.reserve(num_ngrams);
  for (size_t o = 1; o < d2_num.size(); o++) {
    assert(d2_num[o].size() == d2_norm[o].size());
    for (size_t i = 0; i < d2_num[o].size(); i++) {
      d2.push_back(d2_num[o][i] / d2_norm.at(o)[i]);
    }
  }

  fprintf(stderr, "sorting d2\n");
  std::sort(d2.begin(), d2.end());
  
  for (size_t i = 0; i < d2.size(); i++) {
    printf("%g\n", d2[i]);
  }
}
